#include "../utils.h"
#include "../factory_objects.h"
#include "../resources.h"
#include "../camera.h"

typedef struct actor_teleport_s
{
    object_t *self_object;
    sprite_t *sprite;
    vector_t  position;
} actor_teleport_t;

static void _Actor_Teleport_CreateAnimations(actor_teleport_t *actor)
{
    Sprite_AnimationAdd(actor->sprite, "idle", 5);
    Sprite_AnimationAddFrame(actor->sprite, "idle", Utils_GetRect(0,  0, 16, 16));
    Sprite_AnimationAddFrame(actor->sprite, "idle", Utils_GetRect(16, 0, 16, 16));
    Sprite_AnimationAddFrame(actor->sprite, "idle", Utils_GetRect(32, 0, 16, 16));
    Sprite_AnimationAddFrame(actor->sprite, "idle", Utils_GetRect(48, 0, 16, 16));
}

static void _Actor_Teleport_GetInfo(actor_teleport_t *actor, object_info_t *info)
{
    if (actor == NULL)
        return;

    if (info == NULL)
        return;

    info->box_rect       = Utils_GetRect(0, 0, 48, 48);
    info->collision_rect = Utils_GetRect(0, 0, 30, 48);
    info->position       = actor->position;

    if (actor->sprite != NULL)
    {
        info->box_rect.x = actor->position.x - actor->sprite->origin.x;
        info->box_rect.y = actor->position.y - actor->sprite->origin.y;
        info->box_rect.w = actor->sprite->width;
        info->box_rect.h = actor->sprite->height;

        info->collision_rect.x = actor->position.x + 9;
        info->collision_rect.y = actor->position.y;
    }

    info->collision_cell_ul = Utils_GetPoint(0, 0);
    info->collision_cell_br = Utils_GetPoint(0, 0);
}

static void _Actor_Teleport_Collision(actor_teleport_t *actor, void *actor_collision, actor_type_t actor_type)
{
    if (actor == NULL)
        return;

    if (actor_collision == NULL)
        return;

    if (actor_type == AT_ROBO)
    {
        actor_robo_t *robo = (actor_robo_t*)actor_collision;
        vector_t position  = Actor_Robo_GetPosition(robo);

        object_t *object = FactoryObjects_Create();
        Actor_Spawn_Create(object, position.x-24, position.y-39, true);

        Actor_Robo_Remove(robo);
    }
}

static void _Actor_Teleport_Update(actor_teleport_t *actor, float dt)
{
    if (actor == NULL)
        return;

    Sprite_Update(actor->sprite);
}

static void _Actor_Teleport_Draw(SDL_Renderer *renderer, actor_teleport_t *actor)
{
    if (actor == NULL)
        return;

    if (actor->sprite != NULL)
        Sprite_Draw(renderer, actor->sprite, actor->position);
}

static void _Actor_Teleport_Free(actor_teleport_t *actor)
{
    if (actor == NULL)
        return;

    Sprite_Free(actor->sprite);

    free(actor);

    actor = NULL;
}

void Actor_Teleport_Create(object_t *object, float x, float y)
{
    if (object != NULL)
    {
        actor_teleport_t *actor = (actor_teleport_t*) malloc(sizeof(actor_teleport_t));

        actor->self_object = object;

        FactoryObjects_SetActor(object, (void*) actor, AT_SPAWN, OLAY_SPAWN);

        FactoryObjects_SetFunc(object, _Actor_Teleport_GetInfo,   OFUNC_GETINFO);
        FactoryObjects_SetFunc(object, _Actor_Teleport_Collision, OFUNC_COLLISION);
        FactoryObjects_SetFunc(object, _Actor_Teleport_Update,    OFUNC_UPDATE);
        FactoryObjects_SetFunc(object, _Actor_Teleport_Draw,      OFUNC_DRAW);
        FactoryObjects_SetFunc(object, _Actor_Teleport_Free,      OFUNC_FREE);

        actor->sprite       = Sprite_Create(Utils_GetPoint(0, 0), 48, 48, teleportTex);
        actor->position     = Utils_GetVector(x, y);

        _Actor_Teleport_CreateAnimations(actor);

        Sprite_AnimationPlay(actor->sprite, "idle", true);
    }
}
